unit Grid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TGridForm = class(TForm)
    DrawGrid1: TDrawGrid;
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure PaintScreen;
    procedure ClearGrid;
    procedure DisplayStart;
    procedure CountChurches;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GridForm: TGridForm;

implementation

{$R *.DFM}

uses Main, Settings;


procedure TGridForm.DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with DrawGrid1.Canvas do
  begin
    if GridArray[Row,Col] = 'r' then Brush.Color := clRed;
    if GridArray[Row,Col] = 'b' then Brush.Color := clBlue;
    if GridArray[Row,Col] = 'g' then Brush.Color := clGreen;
    if GridArray[Row,Col] = 'y' then Brush.Color := clYellow;
    if GridArray[Row,Col] = 'a' then Brush.Color := clAqua;
    if GridArray[Row,Col] = 'l' then Brush.Color := clLime;
    if GridArray[Row,Col] = 'm' then Brush.Color := clMaroon;
    if GridArray[Row,Col] = 't' then Brush.Color := clTeal;
    if GridArray[Row,Col] = 'f' then Brush.Color := clFuchsia;
    if GridArray[Row,Col] = 's' then Brush.Color := clSilver;
    if GridArray[Row,Col] = 'o' then Brush.Color := clOlive;
    if GridArray[Row,Col] = 'p' then Brush.Color := clPurple;
    if GridArray[Row,Col] = 'n' then Brush.Color := clNavy;
    if GridArray[Row,Col] = 'w' then Brush.Color := clWhite;
    if GridArray[Row,Col] = 'z' then Brush.Color := clBtnFace;
    TextOut(Rect.Left,Rect.Top,'      ');
  end;
end;

procedure TGridForm.PaintScreen;
var
  I, J : integer;
  Carrier : TRect;
  StateSet : TGridDrawState;
begin
  for J := 0 to 99 do
  begin
    for I := 0 to 99 do
    begin
      with GridForm do
      begin
        Carrier := DrawGrid1.CellRect(I,J);
        DrawGrid1DrawCell(GridForm,I,J,Carrier,StateSet);
      end;
    end;
  end;
end;

procedure TGridForm.ClearGrid;
begin
  GridArray := BlankArray;
  PaintScreen;
end;

procedure TGridForm.CountChurches;
var
  I : integer;
begin
  NumReligious := TotalNum-Trunc(TotalNum*PctSecular/100);
  UnitSize := Trunc(NumReligious/(NumSmRel+(NumLgRel*SizeRatio)));
  ChurchCounter := NumSmRel+NumLgRel;
  ShiftToLarge := UnitSize*SizeRatio;
  ShiftToMed := Trunc(UnitSize*SizeRatio/2);
  ShiftToSmall := UnitSize;
  for I := 1 to 11 do
  begin
    ChurchSize[I] := 0;
    LgOrSmNow := 'n';
  end;
  for I := 1 to NumLgRel do
  begin
    ChurchSize[I] := UnitSize*SizeRatio;
    LgOrSmNow[I] := 'l';
  end;
  for I := ChurchCounter-NumSmRel+1 to ChurchCounter do
  begin
    ChurchSize[I] := UnitSize;
    LgOrSmNow[I] := 's';
  end;
  ChurchSize[0] := TotalNum - NumReligious;
  StartChurchSize := ChurchSize;
  StartLgOrSmNow := LgOrSmNow;
end;

procedure TGridForm.DisplayStart;
var
  I, J, K, L, M : integer;
  RunningTotal, LoopCount, RowNum, ColNum : integer;
begin
{  GridForm.FormStyle := fsStayOnTop;}
  if ScreenHeight > 800 then
  begin
    GridForm.Height := 735;
    GridForm.Width := 709;
    GridForm.ClientHeight := 701;
    GridForm.ClientWidth := 701;
    GridForm.Left := Trunc(ScreenWidth/2) - 355;
    GridForm.Top := Trunc(ScreenHeight/2) - 368;
    DrawGrid1.Height := 701;
    DrawGrid1.Width := 701;
    DrawGrid1.DefaultColWidth := 6;
    DrawGrid1.DefaultRowHeight := 6;
  end;
  if ScreenHeight < 700  then
  begin
    GridForm.Height := 535;
    GridForm.Width := 509;
    GridForm.ClientHeight := 501;
    GridForm.ClientWidth := 501;
    GridForm.Left := Trunc(ScreenWidth/2) - 255;
    GridForm.Top := Trunc(ScreenHeight/2) - 268;
    DrawGrid1.Height := 501;
    DrawGrid1.Width := 501;
    DrawGrid1.DefaultColWidth := 4;
    DrawGrid1.DefaultRowHeight := 4;
  end;

  GridForm.Visible := true;
  ClearGrid;
  StartArray := BlankArray;

  RunningTotal := 0;
  for I := 1 to ChurchCounter do
  begin
    for J := 1 to ChurchSize[I] do
    begin
      RowNum := Order[RunningTotal+J];
      if RowNum < 101 then
      begin
        RowNum := 0;
        ColNum := Order[RunningTotal+J]-1;
      end
      else begin
        LoopCount := 0;
        while RowNum > 100 do
        begin
          RowNum := RowNum - 100;
          LoopCount := LoopCount + 1;
        end;
        ColNum := RowNum -1;
        RowNum := LoopCount;
      end; {else}
      GridArray[RowNum,ColNum] := ColorCode[I];
    end;
    RunningTotal := RunningTotal + ChurchSize[I];
  end; {for I -> ChurchCounter}

  {added for version 1.5 -- assigns individual tendency to convert to each square}
  M := 0;
  for I := 0 to 99 do
  begin
    for J := 0 to 99 do
    begin
      M := M+1;
      ConvTendArray[K,L] := M;
      if M = 8 then M := 0;
    end;
  end;

 {3. draw the array};

  StartArray := GridArray;
  PaintScreen;
end;



end.
